# HC_IC64.py - Hill Climbing - search Pins - Lugs are ignored
# Algorithm: very simple (more simple that Sullivan's one)

import string
import sys
import random
import math
from bib_util import *
import pseudo209
import getopt
import time

#======================================
def initKeyPin():
    currentKeyPin= ""
    for i in range( 131 ):
        if random.random() > 0.5: currentKeyPin +="1"
        else: currentKeyPin +="0"
    return currentKeyPin
#======================================
def replace01( ch ):
    result = ""
    for char in ch:
        if char == "0":
           result += "X"
        else:
           result += "Y"
    return result
#======================================
def usage():
    print "usage:"
    print "  -h         Help"
    print "  -c crypto	The cryptogram"
    print "  -t tries 	Number of tries, default: 15"
#--------------------------------------------------
try:
  opts, args = getopt.getopt(sys.argv[1:], 
    "hc:t:v", ["help", "crypto=", "tries=", "verbose"])
except getopt.GetoptError as err:
  # print help information and exit:
  print sys.argv[0],": ", str(err) # option -a not recognized"
  usage()
  sys.exit(2)

verbose = False
MAX_Z = 15
msg = ""

for o, a in opts:
  if o == "-v":
    verbose = True
  elif o in ("-h", "--help"):
    usage()
    sys.exit()
  elif o in ("-c", "--crypto"):
    msg = litfic( a )
  elif o in ("-t", "--tries"):
    MAX_Z = int(a)
  else:
    assert False, "unhandled option"
if msg == "" :
  usage()
  sys.exit(1)
#--------------------------------------------------
e = pseudo209.Hagelin ( 0 )
MAX_SCORE = 0
start_time = time.time()
nod = 0 # number of decrypts
for z in range(    MAX_Z ):
  # 1. Set the external wheels settings to AAAAAA
  e.rewind()

  # 2. Generate initial random pins 
  currentKeyPin = initKeyPin()
  oldKeyPin = currentKeyPin

  #===> Configure key 
  e.setAllPinsAllW( currentKeyPin )

  # --- 2.2 Calculate fitness 
  [ic, tb] = pseudo209.icBy64Box( e, msg )
  HIGH_SCORE = ic

  # 3. Check all pins transformation as long as an improvement
  #    can be achieved
  for limit in range(5000): 
        # --- External Key sets to "AAAAAA"
        e.rewind()
        improved = False

        # --- Toogle a Pin
        tb = list( oldKeyPin )
        j = random.randint(0,130)
        if tb[j] == "1" : x = "0"
        else: x = "1"
        tb[ j ] = x
        currentKeyPin = "".join( tb )
        e.setAllPinsAllW( currentKeyPin )

        # --- Calculate fitness
        [ic,tb] = pseudo209.icBy64Box( e, msg )
        score = ic

        # --- Keep it if best
        if score > HIGH_SCORE :
          HIGH_SCORE = score    		
          oldKeyPin = str(currentKeyPin)
          improved = True
          limit = 0
          tb2 = list(tb)

  if HIGH_SCORE > MAX_SCORE :
    elaps = time.time() - start_time
    MAX_SCORE = HIGH_SCORE
    print z, ">>>MAX SCORE: ", HIGH_SCORE, "==",
    print "CLE: ", replace01( oldKeyPin ), nod, elaps

