# search_xy.py

import sys
import pseudo209
from bib_util import *

# ---- Alpha English inverse
alphaInvEn = [ 162, 16,  4, 13, 13, 22, 77, 51, 64,
  3, 22, 63, 67, 21, 31,  2,  1, 62, 28, 14, 24,109, 35, 26,  8, 62]

# ---- chi2
def chi2( t1, t2):
    N1 = N2 = Scp = 0
    for i in range(26):
        N1  += t1[i]
        N2  += t2[i]
        Scp += t1[i] * t2[i]
    if (N1 == 0) or (N2 == 0): return 0
    return Scp / float( N1 * N2 )

# ---- chi2Pins
def chi2Pins( e, msg ):
    lg = len(msg)
    alpha = [0]*26
    for i in range(lg):
        lettre = string.index(string.ascii_uppercase, msg[i])    
        idx = e.i64()
        if idx == 0:
            alpha[ lettre ] +=1
    return chi2( alphaInvEn, alpha )
# -----------------------------------
def replace01( ch ):
    result = ""
    for char in ch:
        if char == "0":
            result += "X"
        else:
            result += "Y"
    return result
# -----------------------------------
def replaceXY( ch, X, Y ):
    result = ""
    for char in ch:
        if char == "X":
            result += str(X)
        else:
            result += str(Y)
    return result
# -----------------------------------
if len(sys.argv) < 2:
    print "Syntaxe: search_xy.py message KeyPin"
    sys.exit(1)
msg = litfic( sys.argv[1] )
kpin= currentKeyPin = sys.argv[2]

e = pseudo209.Hagelin( 0 )

# 1. Affiche la cle
# x=0, y=1
lesPins = []
lesPins.append( kpin[0:26] ) 
lesPins.append( kpin[26:(26+25)] )
lesPins.append( kpin[(26+25):(26+25+23)] )
lesPins.append( kpin[(26+25+23):(26+25+23+21)] )
lesPins.append( kpin[(26+25+23+21):(26+25+23+21+19)] )
lesPins.append( kpin[(26+25+23+21+19):(26+25+23+21+19+17)])

for uneRoue in lesPins:
    print uneRoue

# 2. On boucle sur les 64 combinaisons
tb = ["---"]*6
for i in range(2):
 tb[0] = replaceXY( lesPins[0], i, i^1 )
 for j in range(2):
  tb[1] = replaceXY( lesPins[1], j, j^1 )
  for k in range(2):
   tb[2] = replaceXY( lesPins[2], k, k^1 )
   for l in range(2):
    tb[3] = replaceXY( lesPins[3], l, l^1 )
    for m in range(2):
     tb[4] = replaceXY( lesPins[4], m, m^1 )
     for n in range(2):
      tb[5] = replaceXY( lesPins[5], n, n^1 )
      print ">>>>>>>",i,j,k,l,m,n,
      currentKeyPin =  "".join(tb)
      e.rewind()
      e.setAllPinsAllW( currentKeyPin )
      unChi = chi2Pins( e, msg )
      print unChi
      print currentKeyPin 
